Subject: Re: netpoll question

From: Mark Huth <[email-masked]>
Date: Wed, 28 Mar 2007 16:28:59 -0700

Steve Wise wrote:
> Hey all,
>
> I have netpoll question.  How does netpoll work with MSI/X, NAPI, and
> nics that setup multiple RSS style receive queues for a single port?
> >From what I can tell, if you're doing something like netdump using
> netpoll for IO, then you might never process incoming packets that get
> posted to the rx queues not associated with the main netdevice structure
> because netpoll only calls the poll() function for the main netdev
> struct.  Not the dummy netdevs setup for multiple rx queues.  
>
> Is this the case or am I confused?
>
> Thanks,
>
>
> Steve
You are correct.  Netpoll needs a bit of work, especially on the receive 
side, for multi-queue and some other possible problems related to taking 
locks when the system is frozen.  If I get some time soon, I'm going to 
propose an overhaul to address some of these issues that show up in the 
kgdboe and netdump cases.

Mark Huth